

#include "ctapi-cherry.h"

#include <stdio.h>
#include <string.h>
#include <errno.h>



int test1(int argc, char **argv) {
  char res;
  unsigned char apdu_init[4]={0x20, 0x12, 0x01, 0x01};
  unsigned char apdu_read[5]={0x00, 0xb0, 0x00, 0x00, 0xff};
  unsigned char apdu_fini[4]={0x20, 0x15, 0x00, 0x00};
  unsigned char sad, dad;
  unsigned short lenr;
  unsigned char response[300];
  FILE *f;

  fprintf(stderr, "Calling CT_init...\n");
  res=CT_init(1, 1);
  if (res!=CC_RV_OK) {
    fprintf(stderr, "Error in CT_init: %d\n", res);
    return 2;
  }

  fprintf(stderr, "Initializing reader...\n");
  lenr=sizeof(response);
  res=CT_data(1, &dad, &sad, sizeof(apdu_init), apdu_init, &lenr, response);
  if (res!=CC_RV_OK) {
    fprintf(stderr, "Error in CT_data(init): %d\n", res);
    return 2;
  }
  else {
    fprintf(stderr, "Result of init: %02x %02x\n",
            (unsigned char)response[lenr-2], (unsigned char)response[lenr-1]);
  }

  fprintf(stderr, "Reading data...\n");
  lenr=sizeof(response);
  res=CT_data(1, &dad, &sad, sizeof(apdu_read), apdu_read, &lenr, response);
  if (res!=CC_RV_OK) {
    fprintf(stderr, "Error in CT_data(read): %d\n", res);
    return 2;
  }
  else {
    fprintf(stderr, "Result of read: %02x %02x\n",
            (unsigned char)response[lenr-2], (unsigned char)response[lenr-1]);
  }

  f=fopen("card.data", "w+");
  if (f==0) {
    fprintf(stderr, "Error opening data file: %s\n",
	    strerror(errno));
    return 2;
  }

  if (1!=fwrite(response, lenr, 1, f)) {
    fprintf(stderr, "Error writing data file: %s\n",
            strerror(errno));
    return 2;
  }

  if (fclose(f)) {
    fprintf(stderr, "Error closing data file: %s\n",
	    strerror(errno));
    return 2;
  }

  fprintf(stderr, "Deinitializing reader...\n");
  lenr=sizeof(response);
  res=CT_data(1, &dad, &sad, sizeof(apdu_fini), apdu_fini, &lenr, response);
  if (res!=CC_RV_OK) {
    fprintf(stderr, "Error in CT_data(fini): %d\n", res);
    return 2;
  }
  else {
    fprintf(stderr, "Result of fini: %02x %02x\n",
            (unsigned char)response[lenr-2], (unsigned char)response[lenr-1]);
  }

  return 0;
}



int test2(int argc, char **argv) {
  char res;
  unsigned char apdu_init[4]={0x20, 0x12, 0x01, 0x01};
  unsigned char apdu_read[5]={0x00, 0xb0, 0x00, 0x00, 0xff};
  unsigned char apdu_fini[4]={0x20, 0x15, 0x00, 0x00};
  unsigned char sad, dad;
  unsigned short lenr;
  unsigned char response[300];
  FILE *f;

  fprintf(stderr, "Calling CT_init...\n");
  res=CT_init(1, 2);
  if (res!=CC_RV_OK) {
    fprintf(stderr, "Error in CT_init: %d\n", res);
    return 2;
  }

  fprintf(stderr, "Initializing reader...\n");
  lenr=sizeof(response);
  res=CT_data(1, &dad, &sad, sizeof(apdu_init), apdu_init, &lenr, response);
  if (res!=CC_RV_OK) {
    fprintf(stderr, "Error in CT_data(init): %d\n", res);
    return 2;
  }
  else {
    fprintf(stderr, "Result of init: %02x %02x\n",
            (unsigned char)response[lenr-2], (unsigned char)response[lenr-1]);
  }

  fprintf(stderr, "Reading data...\n");
  lenr=sizeof(response);
  res=CT_data(1, &dad, &sad, sizeof(apdu_read), apdu_read, &lenr, response);
  if (res!=CC_RV_OK) {
    fprintf(stderr, "Error in CT_data(read): %d\n", res);
    return 2;
  }
  else {
    fprintf(stderr, "Result of read: %02x %02x\n",
            (unsigned char)response[lenr-2], (unsigned char)response[lenr-1]);
  }

  f=fopen("card.data", "w+");
  if (f==0) {
    fprintf(stderr, "Error opening data file: %s\n",
	    strerror(errno));
    return 2;
  }

  if (1!=fwrite(response, lenr, 1, f)) {
    fprintf(stderr, "Error writing data file: %s\n",
            strerror(errno));
    return 2;
  }

  if (fclose(f)) {
    fprintf(stderr, "Error closing data file: %s\n",
	    strerror(errno));
    return 2;
  }

  fprintf(stderr, "Deinitializing reader...\n");
  lenr=sizeof(response);
  res=CT_data(1, &dad, &sad, sizeof(apdu_fini), apdu_fini, &lenr, response);
  if (res!=CC_RV_OK) {
    fprintf(stderr, "Error in CT_data(fini): %d\n", res);
    return 2;
  }
  else {
    fprintf(stderr, "Result of fini: %02x %02x\n",
            (unsigned char)response[lenr-2], (unsigned char)response[lenr-1]);
  }

  return 0;
}



int test3(int argc, char **argv) {
  char res;
  unsigned char apdu_init[4]={0x20, 0x12, 0x01, 0x01};
  unsigned char apdu_read[5]={0x00, 0xb0, 0x00, 0x00, 0xff};
  unsigned char apdu_fini[4]={0x20, 0x15, 0x00, 0x00};
  unsigned char apdu_wait[4]={0x20, 0x13, 0x00, 0x80};
  unsigned char sad, dad;
  unsigned short lenr;
  unsigned char response[300];
  FILE *f;

  fprintf(stderr, "Calling CT_init...\n");
  res=CT_init(1, 2);
  if (res!=CC_RV_OK) {
    fprintf(stderr, "Error in CT_init: %d\n", res);
    return 2;
  }

  fprintf(stderr, "Initializing reader...\n");
  lenr=sizeof(response);
  res=CT_data(1, &dad, &sad, sizeof(apdu_init), apdu_init, &lenr, response);
  if (res!=CC_RV_OK) {
    fprintf(stderr, "Error in CT_data(init): %d\n", res);
    return 2;
  }
  else {
    fprintf(stderr, "Result of init: %02x %02x\n",
            (unsigned char)response[lenr-2], (unsigned char)response[lenr-1]);
  }

  fprintf(stderr, "Waiting for card...\n");
  while(1) {
    lenr=sizeof(response);
    res=CT_data(1, &dad, &sad, sizeof(apdu_wait), apdu_wait, &lenr, response);
    if (res!=CC_RV_OK) {
      fprintf(stderr, "Error in CT_data(wait): %d\n", res);
      return 2;
    }
    else {
      if ((unsigned char)response[lenr-2]==0x90 &&
          (unsigned char)response[lenr-1]==0x00) {
        if (response[2]==0x05) {
          break;
        }
      }
    }
  } /* while */

  fprintf(stderr, "Reading data...\n");
  lenr=sizeof(response);
  res=CT_data(1, &dad, &sad, sizeof(apdu_read), apdu_read, &lenr, response);
  if (res!=CC_RV_OK) {
    fprintf(stderr, "Error in CT_data(read): %d\n", res);
    return 2;
  }
  else {
    fprintf(stderr, "Result of read: %02x %02x\n",
            (unsigned char)response[lenr-2], (unsigned char)response[lenr-1]);
  }

  f=fopen("card.data", "w+");
  if (f==0) {
    fprintf(stderr, "Error opening data file: %s\n",
	    strerror(errno));
    return 2;
  }

  if (1!=fwrite(response, lenr, 1, f)) {
    fprintf(stderr, "Error writing data file: %s\n",
            strerror(errno));
    return 2;
  }

  if (fclose(f)) {
    fprintf(stderr, "Error closing data file: %s\n",
	    strerror(errno));
    return 2;
  }

  fprintf(stderr, "Deinitializing reader...\n");
  lenr=sizeof(response);
  res=CT_data(1, &dad, &sad, sizeof(apdu_fini), apdu_fini, &lenr, response);
  if (res!=CC_RV_OK) {
    fprintf(stderr, "Error in CT_data(fini): %d\n", res);
    return 2;
  }
  else {
    fprintf(stderr, "Result of fini: %02x %02x\n",
            (unsigned char)response[lenr-2], (unsigned char)response[lenr-1]);
  }

  return 0;
}



int main(int argc, char **argv) {
  return test3(argc, argv);
}




